<?php
/***********************************************************************

  Copyright (C) 2007  BN (bnmaster@la-bnbox.info)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
	exit;

// Tell admin_loader.php that this is indeed a plugin and that it is loaded
define('PUN_PLUGIN_LOADED', 1);
define('PLUGIN_VERSION', '1.1');
define('PLUGIN_NAME', 'Uploadile');
define('PLUGIN_URL', 'admin_loader.php?plugin='.$_GET['plugin']);
$tabindex = '1';

/***********************************************************************\
 Languages definitions
\***********************************************************************/
$english_array = array(
'err_3'					=> 'Unable to insert in table %s',
'err_5'					=> 'Unable to delete %s ; please remove manually',

'installation_info'		=> 'Prepare the DB and the cache for '.PLUGIN_NAME.'.',
'installation'			=> 'Install',
'installation_success' 	=> 'Your database has been successfully prepared for '.PLUGIN_NAME.'. See readme.txt for further instructions.',

'update_info'			=> 'Update the cache. (default values)',
'update'				=> 'Update',
'update_success' 		=> 'Your database has been successfully updated for '.PLUGIN_NAME.'.',

'restore_info'			=> 'Restore the DB and modify the cache to uninstall '.PLUGIN_NAME.'.',
'restore'				=> 'Uninstall',
'restore_success'		=> 'Restore of '.PLUGIN_NAME.' (DB and cache) successful.',

'configuration'			=> 'Configuration',
'plugin_desc'			=> 'This plugin makes it possible to configure '.PLUGIN_NAME.' according to your needs.',
'legend'				=> 'Choose your options',
'laws'					=> 'File type allowed',
'laws_info'				=> 'Separate with a coma (,)',
'maxsize_member'		=> 'Max size members can upload',
'maxsize_modo'			=> 'Max size moderators can upload',
'maxsize_info'			=> '<br />N.B : Your server has a default limit.',
'limit_member'			=> 'Place give to members',
'limit_modo'			=> 'Place give to moderators',

'mo'					=> 'Mo value',
'ko'					=> 'Ko value',
'o'						=> 'o value',
);
$french_array = array(
'err_3'					=> 'Impossible d\'insrer dans la table %s',
'err_5'					=> 'Impossible de supprimer %s ; veuillez supprimer manuellement.',

'installation_info'		=> 'Prparer la base de donnes et le cache pour faire fonctionner '.PLUGIN_NAME.'.',
'installation'			=> 'Installer',
'installation_success'		=> 'Votre base de donnes a t correctement prpar pour '.PLUGIN_NAME.'. Veuillez consulter le lisez_moi.txt pour les instructions complmentaires.',

'update_info'			=> 'Mettre  jour le cache. (retour aux valeurs par dfaut)',
'update'				=> 'Mettre  jour',
'update_success'		=> 'Votre base de donnes a t correctement mise  jour pour '.PLUGIN_NAME.'.',

'restore_info'			=> 'Restaurer la base de donnes et modifier le cache pour dsinstaller '.PLUGIN_NAME.'.',
'restore'				=> 'Dsinstaller',
'restore_success'		=> 'Dsinstallation de '.PLUGIN_NAME.' (BDD et cache) russie.',

'configuration'			=> 'Configuration',
'plugin_desc'			=> 'Ce plugin vous permet de grer les options d\''.PLUGIN_NAME.'.',
'legend_2'				=> 'Choisissez votre configuration',
'laws'					=> '<label for="laws">Type de fichier autoris</label>',
'laws_info'				=> 'Spar par une virgule',
'maxsize_member'		=> 'Taille maximale uploadable par les membres',
'maxsize_modo'			=> 'Taille maximale uploadable par les modrateurs',
'maxsize_info'			=> '<br />N.B : Votre serveur admet une limite par dfaut.',
'limit_member'			=> 'Espace allou aux membres',
'limit_modo'			=> 'Espace allou aux modrateurs',

'legend_1'				=> 'Convertisseur',
'mo'					=> 'Valeur en Mo',
'ko'					=> 'Valeur en Ko',
'o'						=> 'Valeur en o',
);

// Set language
if ($pun_user['language'] == 'English')
	$lang = $english_array;
elseif ($pun_user['language'] == 'French')
	$lang = $french_array;

	
// Installation
if (isset($_POST['installation']))
{
	switch($db_type)
	{
		case 'mysql':
		case 'mysqli':
			$sql = 'ALTER TABLE '.$db->prefix.'users '.
			'ADD upload INT(15) NOT NULL DEFAULT 0';
			break;
		
		case 'pgsql':
			$sql = 'ALTER TABLE '.$db->prefix.'users '.
			'ADD upload INT(15) NOT NULL DEFAULT 0';
			break;
		
		case 'sqlite':
			$sql = 'ALTER TABLE '.$db->prefix.'users '.
			'ADD upload INT(15) NOT NULL DEFAULT 0';
			break;
	}
	$db->query($sql) or error(sprintf($lang['err_3'], $db->prefix.'users'), __FILE__, __LINE__, $db->error());

	// delete everything in the cache since we messed with some stuff
	$d = dir(PUN_ROOT.'cache');
	while (($entry = $d->read()) !== false)
	{
		if (substr($entry, strlen($entry)-4) == '.php')
			@unlink(PUN_ROOT.'cache/'.$entry);
	}
	$d->close();
	
	$delete_config = array('o_uploadile_laws', 'o_uploadile_limit_member', 'o_uploadile_limit_modo', 'o_uploadile_maxsize_member', 'o_uploadile_maxsize_modo');
		
	foreach($delete_config as $conf_name)
		$db->query('DELETE FROM '.$db->prefix.'config WHERE conf_name = \''.$conf_name.'\' LIMIT 1;') or error(sprintf($lang_ptb_admin['err_delete'],$conf_name), __FILE__, __LINE__, $db->error());
	
	$setup_config = array(
		'o_uploadile_laws'				=> 'jpg,jpeg,png,gif,swf,odt,ods,doc,xls',
		'o_uploadile_limit_member'		=> '2097152', // 2 mo
		'o_uploadile_limit_modo'		=> '5242880', // 5 mo
		'o_uploadile_maxsize_member'	=> '1258291', // 1.2 mo
		'o_uploadile_maxsize_modo'		=> '1258291' // 1.2 mo
		);
	// N.B :  1 Mo = 1 024 Ko = 1 048 576 o
		
	while (list($conf_name, $conf_value) = @each($setup_config))
		$db->query('INSERT INTO '.$db->prefix."config (conf_name, conf_value) VALUES('$conf_name', '$conf_value')") or error(sprintf($lang_ptb_admin['err_insert'],$conf_name), __FILE__, __LINE__, $db->error());
	
	// Regenerate the config cache
	require_once PUN_ROOT.'include/cache.php';
	generate_config_cache();

	redirect(PLUGIN_URL, $lang['installation_success']);
	exit;
}
// MAJ
if(isset($_POST['update']))
{
	$delete_config = array('o_uploadile_laws', 'o_uploadile_limit_member', 'o_uploadile_limit_modo', 'o_uploadile_maxsize_member', 'o_uploadile_maxsize_modo');
	foreach($delete_config as $conf_name)
		$db->query('DELETE FROM '.$db->prefix.'config WHERE conf_name = \''.$conf_name.'\' LIMIT 1;') or error(sprintf($lang_ptb_admin['err_delete'],$conf_name), __FILE__, __LINE__, $db->error());
	
	if(isset($_POST['laws']))
		$laws = addslashes(htmlentities(str_replace(' ', '', $_POST['laws'])));
	else
		$laws = 'jpg,jpeg,png,gif,swf,odt,ods,doc,xls';
	if(isset($_POST['limit_member']))
		$limit_member = addslashes(htmlentities($_POST['limit_member']));
	else
		$limit_member = '2097152';
	if(isset($_POST['limit_modo']))
		$limit_modo = addslashes(htmlentities($_POST['limit_modo']));
	else
		$limit_modo = '5242880';
	if(isset($_POST['maxsize_member']))
		$maxsize_member = addslashes(htmlentities($_POST['maxsize_member']));
	else
		$maxsize_member = '1258291';
	if(isset($_POST['maxsize_modo']))
		$maxsize_modo = addslashes(htmlentities($_POST['maxsize_modo']));
	else
		$maxsize_modo = '1258291';
	$setup_config = array(
	'o_uploadile_laws'				=> $laws,
	'o_uploadile_limit_member'		=> $limit_member,
	'o_uploadile_limit_modo'		=> $limit_modo,
	'o_uploadile_maxsize_member'	=> $maxsize_member,
	'o_uploadile_maxsize_modo'		=> $maxsize_modo
	);
	while (list($conf_name, $conf_value) = @each($setup_config))
		$db->query('INSERT INTO '.$db->prefix."config (conf_name, conf_value) VALUES('$conf_name', '$conf_value')") or error(sprintf($lang_ptb_admin['err_insert'],$conf_name), __FILE__, __LINE__, $db->error());
	
	// Regenerate the config cache
	require_once PUN_ROOT.'include/cache.php';
	generate_config_cache();

	redirect(PLUGIN_URL, $lang['update_success']);
	exit;
}
// Dsinstallation
if (isset($_POST['restore']))
{
	// Cache
	$delete_config = array('o_uploadile_laws', 'o_uploadile_limit_member', 'o_uploadile_limit_modo', 'o_uploadile_maxsize_member', 'o_uploadile_maxsize_modo');
	foreach($delete_config as $conf_name)
		$db->query('DELETE FROM '.$db->prefix.'config WHERE conf_name = \''.$conf_name.'\' LIMIT 1;') or error(sprintf($lang_ptb_admin['err_delete'],$conf_name), __FILE__, __LINE__, $db->error());
	// Regenerate the config cache
	require_once PUN_ROOT.'include/cache.php';
	generate_config_cache();
	
	// BDD
	$errors = array();
	if (!$db->query('ALTER TABLE '.$db->prefix.'users DROP upload;'))
		$errors[] = sprintf($lang['err_5'], $db->prefix.'users =&gt; upload');

	// delete everything in the cache since we messed with some stuff
	$d = dir(PUN_ROOT.'cache');
	while (($entry = $d->read()) !== false)
	{
		if (substr($entry, strlen($entry)-4) == '.php')
			@unlink(PUN_ROOT.'cache/'.$entry);
	}
	$d->close();	
	
	if (!empty($errors))
		error('<ul><li>'.implode('</li><li>',$errors).'</li></ul>', '', '');

	redirect(PLUGIN_URL, $lang['restore_success']);
	exit;
}

	// Display the admin navigation menu
	generate_admin_menu($plugin);
	?>
	<div id="uploadile" class="blockform">
		<h2><span><?php echo PLUGIN_NAME; ?> v.<?php echo PLUGIN_VERSION; ?></span></h2>
		<div class="box">
			<div class="inbox">
				<p><?php echo $lang['plugin_desc'] ?></p>
				<form action="<?php echo PLUGIN_URL; ?>" method="post">
					<p><?php echo $lang['installation_info'] ?><br />
					<input type="submit" name="installation" value="<?php echo $lang['installation'] ?>" />
					<br /><br />
					<?php echo $lang['update_info'] ?><br />
					<input type="submit" name="update" value="<?php echo $lang['update'] ?>" />
					<br /><br />
					<?php echo $lang['restore_info'] ?><br />
					<input type="submit" name="restore" value="<?php echo $lang['restore'] ?>" /></p>
				</form>
			</div>
		</div>

		<h2 class="block2"><span><?php echo $lang['configuration'] ?></span></h2>
		<div class="box">
			<form method="post" action="<?php echo PLUGIN_URL; ?>">
				<div class="inform">
					<fieldset>
						<legend><?php echo $lang['legend_1'] ?></legend>
						<label for="mo"><?php echo $lang['mo'] ?></label> <input type="text" name="mo" id="mo" size="15" tabindex="<?php echo $tabindex++; ?>" /> <input type="button" value="Convertir" tabindex="<?php echo $tabindex++; ?>" onclick="javascript:document.getElementById('ko').value=document.getElementById('mo').value*1024; document.getElementById('o').value=document.getElementById('mo').value*1048576;" />
						<label for="ko"><?php echo $lang['ko'] ?></label> <input type="text" name="ko" id="ko" size="15" tabindex="<?php echo $tabindex++; ?>" /> <input type="button" value="Convertir" tabindex="<?php echo $tabindex++; ?>" onclick="javascript:document.getElementById('mo').value=document.getElementById('ko').value/1024; document.getElementById('o').value=document.getElementById('ko').value*1048576;"/>
						<label for="o"><?php echo $lang['o'] ?></label> <input type="text" name="o" id="o" size="15" tabindex="<?php echo $tabindex++; ?>" /> <input type="button" value="Convertir" tabindex="<?php echo $tabindex++; ?>" onclick="javascript:document.getElementById('mo').value=document.getElementById('o').value/1048576; document.getElementById('ko').value=(document.getElementById('o').value*1024)/1048576;"/>
						<p>N.B : 1 Mo = 1 024 Ko = 1 048 576 o</p>
					</fieldset>
				</div>
				<p class="submitend"><input type="submit" name="update" value="<?php echo $lang['update']; ?>" /></p>
				<div class="inform">
					<fieldset>
						<legend><?php echo $lang['legend_2'] ?></legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row"><label for="laws"><?php echo $lang['laws'] ?></label></th>
								<td>
									<input type="text" name="laws"  id="laws" size="40" tabindex="<?php echo $tabindex++; ?>" value="<?php echo @$pun_config['o_uploadile_laws'] ?>" />
									<?php echo $lang['laws_info'] ?>
								</td>
							</tr>
							<tr>
								<th scope="row"><label for="maxsize_member"><?php echo $lang['maxsize_member'] ?></label></th>
								<td>
									<input type="text" name="maxsize_member" id="maxsize_member" size="15" tabindex="<?php echo $tabindex++; ?>" value="<?php echo @$pun_config['o_uploadile_maxsize_member'] ?>" /> octets
									<?php echo $lang['maxsize_info'] ?>
								</td>
							</tr>
							<tr>
								<th scope="row"><label for="limit_member"><?php echo $lang['limit_member'] ?></label></th>
								<td>
									<input type="text" name="limit_member" id="limit_member" size="15" tabindex="<?php echo $tabindex++; ?>" value="<?php echo @$pun_config['o_uploadile_limit_member'] ?>" /> octets
								</td>
							</tr>
							<tr>
								<th scope="row"><label for="maxsize_modo"><?php echo $lang['maxsize_modo'] ?></label></th>
								<td>
									<input type="text" name="maxsize_modo" id="maxsize_modo" size="15" tabindex="<?php echo $tabindex++; ?>" value="<?php echo @$pun_config['o_uploadile_maxsize_modo'] ?>" /> octets
									<?php echo $lang['maxsize_info'] ?>
								</td>
							</tr>
							<tr>
								<th scope="row"><label for="limit_modo"><?php echo $lang['limit_modo'] ?></label></th>
								<td>
									<input type="text" name="limit_modo" id="limit_modo" size="15" tabindex="<?php echo $tabindex++; ?>" value="<?php echo @$pun_config['o_uploadile_limit_modo'] ?>" /> octets
								</td>
							</tr>
						</table>
						</div>
					</fieldset>
					<p class="submitend"><input type="submit" name="update" value="<?php echo $lang['update']; ?>" /></p>
				</div>
			</form>
		</div>
	</div>